unit APIman1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, OleCtnrs, clipbrd, ExtDlgs, Titlebar;

type
  TForm1 = class(TForm)
    Titlebar1: TTitlebar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lblHandle: TLabel;
    Label5: TLabel;
    txtLeft: TEdit;
    txtTop: TEdit;
    txtRight: TEdit;
    txtBottom: TEdit;
    btnGetList: TButton;
    txtSet: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    ArrangeWin: TButton;
    btnPaint: TButton;
    exwin: TComboBox;
    Button7: TButton;
    Button9: TButton;
    All: TCheckBox;
    Animate: TCheckBox;
    WinState: TComboBox;
    ListBox1: TListBox;
    cmdFlash: TButton;
    btnStayonTop: TButton;
    btnMakeNormal: TButton;
    ScrollBar1: TScrollBar;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button3: TButton;
    btnScreenSaver: TButton;
    ColorDialog1: TColorDialog;
    Timer1: TTimer;
    Timer2: TTimer;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Remove1: TMenuItem;
    tmrFlash: TTimer;
    spd: TSavePictureDialog;
    OpenDialog1: TOpenPictureDialog;
    CheckBox1: TCheckBox;
    procedure GetList;
    procedure btnGetListClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SetTextBoxes(I: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ArrangeWinClick(Sender: TObject);
    procedure btnPaintClick(Sender: TObject);
    procedure GetVisibleList;
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure AnimateClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Remove1Click(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cmdFlashClick(Sender: TObject);
    procedure tmrFlashTimer(Sender: TObject);
    procedure btnStayonTopClick(Sender: TObject);
    procedure btnMakeNormalClick(Sender: TObject);
    procedure ArrangeWinMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure Button3Click(Sender: TObject);
    procedure btnScreenSaverClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MD: Byte;

implementation

uses Unit2;

{$R *.DFM}
{$H-}

procedure TForm1.SetTextBoxes(I: Integer);
var
  WR: TRect;
  Index: Integer;
  intP: Integer;

  L: Integer;
  S: String;
begin

     lblHandle.Caption := IntToStr(I);
     S := '';
     while Length(S) < 255 do S := S + ' ';
     L := GetWindowText( I, Addr(S[1]), 255);
     S := Copy(S, 1, L);
     txtSet.Text := S;

     BitBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, Image1.Canvas.Handle, 0, 0, WHITENESS);

     intP := I;
     intP := GetDC( intP );
     BitBlt(Image1.Canvas.Handle, 0, 0, Image1.Width, Image1.Height, intP, 0, 0, SRCCopy);
     Image1.Repaint;
     ReleaseDC( I, intP );

     GetWindowRect(I, WR);
     txtLeft.Text := IntToStr(WR.Left);
     txtTop.Text := IntToStr(WR.Top);
     txtRight.Text := IntToStr(WR.Right - WR.Left);
     txtBottom.Text := IntToStr(WR.Bottom - WR.Top);

end;

procedure TForm1.GetList;
var
  I: Integer;
  H: LongInt;
begin
    ListBox1.Clear;
    H := GetTopWindow(GetDesktopWindow);
    While H <> 0 do begin
        ListBox1.Items.Add( IntToStr(H) );
        H := GetNextWindow(H,GW_HWNDNEXT);
    end;
    if ListBox1.Items.Count > 0 then lblHandle.Caption := ListBox1.Items.Strings[0];

end;

procedure TForm1.btnGetListClick(Sender: TObject);
begin
     if All.Checked then GetList else GetVisibleList;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
     if ListBox1.ItemIndex = -1 then ListBox1.ItemIndex := 0;
     SetTextBoxes( StrToInt(ListBox1.Items.Strings[ ListBox1.ItemIndex ]) );
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  S: String;
  P: PChar;
  I: Integer;
  H: Integer;
begin

   if All.Checked = False Then begin
     S := txtSet.Text;
     P := Addr(S[1]);
     SetWindowText( StrToInt(lblHandle.Caption), P);
   end else For I := 0 to ListBox1.Items.Count - 1 do begin

     H := StrToInt(ListBox1.Items.Strings[ I ]);
     S := txtSet.Text;
     P := Addr(S[1]);
     SetWindowText( H, P);

   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   WR: TRect;
   I: Integer;
   H: Integer;
begin
   if All.Checked = False then begin
     WR.Left := STrToInt(txtLeft.Text);
     WR.Top := STrToInt(txtTop.Text);
     WR.Right := STrToInt(txtRight.Text);
     WR.Bottom := STrToInt(txtBottom.Text);
     MoveWindow( StrToInt(lblHandle.Caption), WR.Left, WR.Top, WR.Right, WR.Bottom, True);
   end else for I := 0 to ListBox1.Items.Count - 1 do begin
     H := StrToInt( ListBox1.Items.Strings[ I ] );
     WR.Left := STrToInt(txtLeft.Text);
     WR.Top := STrToInt(txtTop.Text);
     WR.Right := STrToInt(txtRight.Text);
     WR.Bottom := STrToInt(txtBottom.Text);
     MoveWindow( H, WR.Left, WR.Top, WR.Right, WR.Bottom, True);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
     P: Integer;
begin
//     Application.HintPause := 5000;
//     Application.ShowHint := True;
     GetVisibleList;
     P := StrToInt(ListBox1.Items.Strings[0]);
     lblHandle.Caption := IntToStr( P );
     SetTextBoxes( P );
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     if Timer1.Enabled = False then begin
        Timer1.Enabled := True;
        Button4.Caption := 'Quake is on';
     end else begin
        Timer1.Enabled := False;
        Button4.Caption := 'Quake is off';
     end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  I, H: Integer;
  WR: TRect;
  RndL, RndT: Integer;
  Scrn: TScreen;
begin
   Scrn := TScreen.Create(Owner);
   if All.Checked = True then begin
     For I := 0 to ListBox1.Items.Count - 1 do begin
       H := StrToInt(ListBox1.Items.Strings[I]);
       if IsWindowVisible(H) then begin
        GetWindowRect(H, WR);
        WR.Right := WR.Right - WR.Left;
        WR.Bottom := WR.Bottom - WR.Top;
        Randomize;
        RndL := Random(11) - 5;
        RndT := Random(11) - 5;
        WR.Left := WR.Left + RndL;
        WR.Top := WR.Top + RndT;
        if WR.Left < 0 then WR.Left := 0;
        if WR.Top < 0 then WR.Top := 0;
        if WR.Right + WR.Left > Scrn.Width then WR.Left := WR.Left - RndL;
        if WR.Bottom + WR.Top > Scrn.Height then WR.Top := WR.Top - RndT;
        MoveWindow( H, WR.Left, WR.Top, WR.Right, WR.Bottom, True);
       end;
     end;
   end else begin
     H := StrToInt(lblHandle.Caption);
     GetWindowRect(H, WR);
     WR.Right := WR.Right - WR.Left;
     WR.Bottom := WR.Bottom - WR.Top;
     Randomize;
     RndL := Random(11) - 5;
     RndT := Random(11) - 5;
     WR.Left := WR.Left + RndL;
     WR.Top := WR.Top + RndT;
     if WR.Left < 0 then WR.Left := 0;
     if WR.Top < 0 then WR.Top := 0;
     if WR.Right + WR.Left > Scrn.Width then WR.Left := WR.Left - RndL;
     if WR.Bottom + WR.Top > Scrn.Height then WR.Top := WR.Top - RndT;
     MoveWindow( H, WR.Left, WR.Top, WR.Right, WR.Bottom, True);
   end;
   Scrn.Free;
end;

procedure TForm1.ArrangeWinClick(Sender: TObject);
begin

     if ArrangeWin.Caption = 'Cascade Windows' then
        CascadeWindows( GetDesktopWindow, MDITILE_SKIPDISABLED, nil, 0, nil)
     else
        TileWindows( GetDesktopWindow, MDITILE_SKIPDISABLED + MDITILE_HORIZONTAL, nil, 0, nil);


end;


procedure TForm1.GetVisibleList;
var
  I: Integer;
  H: LongInt;
begin
     ListBox1.Clear;
     H := GetTopWindow(GetDesktopWindow);
     While H <> 0 do begin
         if IsWindowVisible(H) then ListBox1.Items.Add( IntToStr(H) );
         H := GetNextWindow(H,GW_HWNDNEXT);
     end;
     if ListBox1.Items.Count > 0 then lblHandle.Caption := ListBox1.Items.Strings[0];
end;

procedure TForm1.btnPaintClick(Sender: TObject);
var
   WR: TRECT;
   H: Integer;
   I: Integer;
begin
     OpenDialog1.Execute;
     if OpenDialog1.FileName <> '' then begin
         Image1.Picture.LoadFromFile( OpenDialog1.FileName );

         if All.Checked = False then begin
            H := StrToInt(lblHandle.Caption);
            H := GetDC( H );
            if H < 1 then H := StrToInt(lblHandle.Caption);

            BitBlt( H, 0, 0, Image1.Width, Image1.Height,
                 Image1.Canvas.Handle, 0, 0, SRCCopy );
            ReleaseDC( StrToInt(lblHandle.Caption), H);
         end else For I := 0 to ListBox1.Items.Count - 1 do begin
            H := StrToInt(ListBox1.Items.Strings[ I ] );
            H := GetDC( H );
            if H < 1 then H := StrToInt(lblHandle.Caption);
            BitBlt( H, 0, 0, Image1.Width, Image1.Height,
                 Image1.Canvas.Handle, 0, 0, SRCCopy );
            ReleaseDC( StrToInt(ListBox1.Items.Strings[ I ] ), H);

         end;

{         GetWindowRect( H, WR);
         WR.Right := WR.Right - WR.Left;
         WR.Bottom := WR.Bottom - WR.Top;
         SetWindowPos( H, HWND_TOP, WR.Left, WR.Top, WR.Right, WR.Bottom, SWP_SHOWWINDOW );
}
     end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
   I: Byte;
begin

  if exwin.Text = 'Force' then I := EWX_FORCE else
   if exwin.Text = 'LogOff' then I := EWX_LOGOFF else
    if exwin.Text = 'PowerOff' then I := EWX_POWEROFF else
     if exwin.Text = 'Reboot' then I := EWX_REBOOT else
      if exwin.Text = 'Shutdown' then I := EWX_SHUTDOWN else Exit;

  if MessageBox( Form1.Handle, 'You sure you want to?', 'API Man', 1) = IDOK then ExitWindowsEx(I,0);

end;

procedure TForm1.Button9Click(Sender: TObject);
var
   H: Integer;
   I: LongInt;
   Con: LongInt;
begin                                       

  if WinState.Text = 'Close' then begin
     if All.Checked = False then begin
        H := StrToInt( lblHandle.Caption );
        DefWindowProc( H, WM_SYSCOMMAND, SC_CLOSE, 0);
     end else for I := 0 to ListBox1.Items.Count - 1 do begin
        H := StrToInt( ListBox1.Items.Strings[ I ] );
        DefWindowProc( H, WM_SYSCOMMAND, SC_CLOSE, 0);
     end;
   end;

  if WinState.Text = 'Hide' then Con := SW_HIDE;
  if WinState.Text = 'Maximize' then Con := SW_MAXIMIZE;
  if WinState.Text = 'Minimize' then Con := SW_MINIMIZE;
  if WinState.Text = 'Restore' then Con := SW_RESTORE;
  if WinState.Text = 'Show' then Con := SW_SHOW;
  if WinState.Text = 'Show Default' then Con := SW_SHOWDEFAULT;
  if WinState.Text = 'Show Maximized' then Con := SW_SHOWMAXIMIZED;
  if WinState.Text = 'Show Minimized' then Con := SW_SHOWMINIMIZED;
  if WinState.Text = 'Show Minimized Not Active' then Con := SW_SHOWMINNOACTIVE;
  if WinState.Text = 'Show Not Active' then Con := SW_SHOWNA;
  if WinState.Text = 'Show Dont Activate' then Con := SW_SHOWNOACTIVATE;
  if WinState.Text = 'Show Normal' then Con := SW_SHOWNORMAL;

  if All.Checked = False then begin
     H := StrToInt( lblHandle.Caption );
     ShowWindow(H, Con);
  end else for I := 0 to ListBox1.Items.Count - 1 do begin
     H := StrToInt( ListBox1.Items.Strings[ I ] );
     ShowWindow(H, Con);
  end;

  ShowWindow( Form1.Handle , SW_SHOW );

end;

procedure TForm1.AnimateClick(Sender: TObject);
begin
if Animate.Checked = True then Timer2.Enabled := True else Timer2.Enabled := False;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
SetTextBoxes( StrToInt( lblHandle.Caption ) );
end;

procedure TForm1.Add1Click(Sender: TObject);
var
   S: String;
begin
S := InputBox( 'Must be a integer', 'Handle to add : ', '' );
  try
     StrToInt( S );
     lblHandle.Caption := S;
     listbox1.Items.Add( S );
  finally

  end;
end;

procedure TForm1.Remove1Click(Sender: TObject);
begin
ListBox1.Items.Delete( ListBox1.ItemIndex );
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
MD := 1;
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if MD = 1 then begin
      X := (Y div ListBox1.ItemHeight) + GetScrollPos( ListBox1.Handle , SB_VERT );
      if X < 1 then X := 0;
      if X >= ListBox1.Items.Count then X := ListBox1.Items.Count - 1;
      ListBox1.ItemIndex := X;
      SetTextBoxes( StrToInt(ListBox1.Items.Strings[ ListBox1.ItemIndex] )) ;
   end;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
MD := 0;
end;

procedure TForm1.cmdFlashClick(Sender: TObject);
begin
     if tmrFlash.Enabled = False then begin
        tmrFlash.Enabled := True;
        cmdFlash.Caption := 'Flash is on';
     end else begin
        tmrFlash.Enabled := False;
        cmdFlash.Caption := 'Flash is off';       
     end;
end;

procedure TForm1.tmrFlashTimer(Sender: TObject);
var
  I: Integer;
  H: Integer;
begin
   if All.Checked = False Then begin
     FlashWindow( StrToInt(lblHandle.Caption), True);
   end else For I := 0 to ListBox1.Items.Count - 1 do begin
     H := StrToInt(ListBox1.Items.Strings[ I ]);
     FlashWindow( H, True);
   end;
end;


procedure TForm1.btnStayonTopClick(Sender: TObject);
var
   I: Integer;
   H: Integer;
begin
   if All.Checked = False then begin
     H := StrToInt(lblHandle.Caption);
     SetWindowPos(H, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE + SWP_NOSIZE + SWP_SHOWWINDOW);
   end else for I := 0 to ListBox1.Items.Count - 1 do begin
     H := StrToInt( ListBox1.Items.Strings[ I ] );
     SetWindowPos(H, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE + SWP_NOSIZE + SWP_SHOWWINDOW);
   end;
end;


procedure TForm1.btnMakeNormalClick(Sender: TObject);
var
   I: Integer;
   H: Integer;
begin
   if All.Checked = False then begin
     H := StrToInt(lblHandle.Caption);
     SetWindowPos(H, HWND_NOTOPMOST, 0,0,0,0, SWP_NOMOVE + SWP_NOSIZE + SWP_SHOWWINDOW);
   end else for I := 0 to ListBox1.Items.Count - 1 do begin
     H := StrToInt( ListBox1.Items.Strings[ I ] );
     SetWindowPos(H, HWND_NOTOPMOST, 0,0,0,0, SWP_NOMOVE + SWP_NOSIZE + SWP_SHOWWINDOW);
   end;
end;



procedure TForm1.ArrangeWinMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

        if Button = mbRight then begin
                if ArrangeWin.Caption = 'Cascade Windows' then
                   ArrangeWin.Caption := 'Tile Windows' else
                   ArrangeWin.Caption := 'Cascade Windows';
        end;

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   Temp: TForm;
begin

 if Button = mbLeft then begin
   if ScrollBar1.Position > 0 then ScrollBar1.Position := 0;

   Temp := TForm.Create( Self );

   Temp.Left := Form1.Left + ScrollBox1.Left + 6;
   Temp.Top := Form1.Top + ScrollBox1.Top + 25;
   Temp.Width := ScrollBox1.Width;
   Temp.Height := ScrollBox1.Height;
   Temp.Visible := True;

   ShowWindow( Temp.Handle, SW_HIDE );
   Image1.Update;

	If button = mbleft then
	begin
		releasecapture;
      DefWindowProc( Temp.Handle, WM_syscommand, $F012, 0);
	end;

   txtLeft.Text := IntToStr( Temp.Left );
   txtTop.Text := IntToStr( Temp.Top );
   txtRight.Text := IntToStr( Temp.Width );
   txtBottom.Text := IntToStr( Temp.Height );


   Temp.Tag := GetDc( GetDesktopWindow );

   BitBlt(Image1.Canvas.Handle, 0, 0, Temp.Width, Temp.Height, Temp.Tag, Temp.Left, Temp.Top, SRCCopy);
   Image1.Refresh;

   ReleaseDc( GetDesktopWindow, Temp.Tag );

   Temp.Free;

 end else begin

   spd.Execute;
   if spd.FileName <> '' then Image1.Picture.SaveToFile( spd.FileName );

 end;

end;

procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin

   ScrollBox1.HorzScrollBar.Range := ScrollBox1.Height * ScrollBar1.Position;
   ScrollBox1.VertScrollBar.Range := ScrollBox1.HorzScrollBar.Range;
   ScrollBox1.HorzScrollBar.Increment := ScrollBar1.Position + 1;
   ScrollBox1.VertScrollBar.Increment := ScrollBar1.Position + 1;
   ScrollBox1.HorzScrollBar.Position := 1;
   ScrollBox1.HorzScrollBar.Position := 0;
   ScrollBox1.VertScrollBar.Position := 0;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  H, I: Integer;
  ico: TIcon;
  oldFilter: String;
begin

   H := StrToInt(lblHandle.Caption);
   oldFilter := OpenDialog1.Filter;
   opendialog1.Filter := 'Icons(*.ico)';
   OpenDialog1.DefaultExt := '*.ico';
   if OpenDialog1.Execute then begin
      ico := TIcon.Create;
      ico.LoadFromFile( OpenDialog1.FileName );
      for I := 0 to ListBox1.Items.Count - 1 do begin
         H := StrToInt( ListBox1.Items.Strings[ I ] );
         DefWindowProc( H, WM_SETICON, 1, ico.Handle );
      end; 
      ico.Free;
   end;
   OpenDialog1.Filter := oldFilter;
   OpenDialog1.DefaultExt := '*.bmp';

end;

procedure TForm1.btnScreenSaverClick(Sender: TObject);
begin

   DefWindowProc( Form1.Handle, WM_SYSCOMMAND, SC_SCREENSAVE, 0 );

end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin

   TitleBar1.AutoHide := CheckBox1.Checked;

end;

end.


